## miniupnpc 1.5

=== Makefile ===
# $Id: Makefile,v 1.68 2010/12/21 16:13:14 nanard Exp $
# MiniUPnP Project
# http://miniupnp.free.fr/
# (c) 2005-2010 Thomas Bernard
# to install use :
# $ PREFIX=/tmp/dummylocation make install
# or
# $ INSTALLPREFIX=/usr/local make install
# or 
# make install (will go to /usr/bin, /usr/lib, etc...)
OS = $(shell uname -s)
CC ?= gcc
#AR = gar
#CFLAGS = -O -Wall -g -DDEBUG
CFLAGS ?= -O -Wall -DNDEBUG -DMINIUPNPC_SET_SOCKET_TIMEOUT
# -DNO_GETADDRINFO
INSTALL = install
SH = /bin/sh
JAVA = java
# see http://code.google.com/p/jnaerator/
JNAERATOR = jnaerator-0.9.3.jar
#following libs are needed on Solaris
#LDLIBS=-lsocket -lnsl -lresolv

# APIVERSION is used to build SONAME
APIVERSION = 5

SRCS = igd_desc_parse.c miniupnpc.c minixml.c minisoap.c miniwget.c \
       upnpc.c upnpcommands.c upnpreplyparse.c testminixml.c \
	   minixmlvalid.c testupnpreplyparse.c minissdpc.c \
	   upnperrors.c testigddescparse.c testminiwget.c \
       connecthostport.c

LIBOBJS = miniwget.o minixml.o igd_desc_parse.o minisoap.o \
          miniupnpc.o upnpreplyparse.o upnpcommands.o upnperrors.o \
          connecthostport.o

ifneq ($(OS), AmigaOS)
CFLAGS := -fPIC $(CFLAGS)
LIBOBJS := $(LIBOBJS) minissdpc.o
endif

OBJS = $(patsubst %.c,%.o,$(SRCS))

# HEADERS to install
HEADERS = miniupnpc.h miniwget.h upnpcommands.h igd_desc_parse.h \
          upnpreplyparse.h upnperrors.h declspec.h
# library names
LIBRARY = libminiupnpc.a
ifeq ($(OS), Darwin)
  SHAREDLIBRARY = libminiupnpc.dylib
  SONAME = $(basename $(SHAREDLIBRARY)).$(APIVERSION).dylib
  CFLAGS := -DMACOSX -D_DARWIN_C_SOURCE $(CFLAGS)
else 
  SHAREDLIBRARY = libminiupnpc.so
  SONAME = $(SHAREDLIBRARY).$(APIVERSION)
endif

EXECUTABLES = upnpc-static
EXECUTABLES_ADDTESTS = testminixml minixmlvalid testupnpreplyparse \
			  testigddescparse testminiwget

TESTMINIXMLOBJS = minixml.o igd_desc_parse.o testminixml.o

TESTMINIWGETOBJS = miniwget.o testminiwget.o miniupnpc.o minisoap.o \
                   upnpcommands.o upnpreplyparse.o minixml.o \
                   igd_desc_parse.o connecthostport.o

TESTUPNPREPLYPARSE = testupnpreplyparse.o minixml.o upnpreplyparse.o

TESTIGDDESCPARSE = testigddescparse.o igd_desc_parse.o minixml.o \
                   miniupnpc.o miniwget.o upnpcommands.o upnpreplyparse.o \
                   minisoap.o connecthostport.o

ifneq ($(OS), AmigaOS)
EXECUTABLES := $(EXECUTABLES) upnpc-shared
TESTMINIWGETOBJS := $(TESTMINIWGETOBJS) minissdpc.o
TESTIGDDESCPARSE := $(TESTIGDDESCPARSE) minissdpc.o
endif

# install directories
INSTALLPREFIX ?= $(PREFIX)/usr
INSTALLDIRINC = $(INSTALLPREFIX)/include/miniupnpc
INSTALLDIRLIB = $(INSTALLPREFIX)/lib
INSTALLDIRBIN = $(INSTALLPREFIX)/bin

FILESTOINSTALL = $(LIBRARY) $(EXECUTABLES)
ifneq ($(OS), AmigaOS)
FILESTOINSTALL := $(FILESTOINSTALL) $(SHAREDLIBRARY)
endif


.PHONY:	install clean depend all check everything installpythonmodule \
	validateminixml

all:	$(LIBRARY) $(EXECUTABLES)

check:	validateminixml

everything:	all $(EXECUTABLES_ADDTESTS)

pythonmodule:	$(LIBRARY) miniupnpcmodule.c setup.py
	python setup.py build
	touch $@

installpythonmodule:	pythonmodule
	python setup.py install

validateminixml:	minixmlvalid
	@echo "minixml validation test"
	./minixmlvalid
	touch $@

clean:
	$(RM) $(LIBRARY) $(SHAREDLIBRARY) $(EXECUTABLES) $(OBJS) miniupnpcstrings.h
	# clean python stuff
	$(RM) pythonmodule validateminixml
	$(RM) -r build/ dist/
	#python setup.py clean

install:	$(FILESTOINSTALL)
	$(INSTALL) -d $(INSTALLDIRINC)
	$(INSTALL) -m 644 $(HEADERS) $(INSTALLDIRINC)
	$(INSTALL) -d $(INSTALLDIRLIB)
	$(INSTALL) -m 644 $(LIBRARY) $(INSTALLDIRLIB)
ifneq ($(OS), AmigaOS)
	$(INSTALL) -m 644 $(SHAREDLIBRARY) $(INSTALLDIRLIB)/$(SONAME)
	ln -fs $(SONAME) $(INSTALLDIRLIB)/$(SHAREDLIBRARY)
endif
	$(INSTALL) -d $(INSTALLDIRBIN)
ifeq ($(OS), AmigaOS)
	$(INSTALL) -m 755 upnpc-static $(INSTALLDIRBIN)/upnpc
else
	$(INSTALL) -m 755 upnpc-shared $(INSTALLDIRBIN)/upnpc
endif
	$(INSTALL) -m 755 external-ip.sh $(INSTALLDIRBIN)/external-ip

cleaninstall:
	$(RM) -r $(INSTALLDIRINC)
	$(RM) $(INSTALLDIRLIB)/$(LIBRARY)
	$(RM) $(INSTALLDIRLIB)/$(SHAREDLIBRARY)

depend:
	makedepend -Y -- $(CFLAGS) -- $(SRCS) 2>/dev/null

$(LIBRARY):	$(LIBOBJS)
	$(AR) crs $@ $?

$(SHAREDLIBRARY):	$(LIBOBJS)
ifeq ($(OS), Darwin)
	$(CC) -dynamiclib $(LDFLAGS) -Wl,-install_name,$(SONAME) -o $@ $^ 
else
	$(CC) -shared $(LDFLAGS) -Wl,-soname,$(SONAME) -o $@ $^
endif

upnpc-static:	upnpc.o $(LIBRARY) $(LDLIBS)
	$(CC) $(LDFLAGS) -o $@ $^

upnpc-shared:	upnpc.o $(SHAREDLIBRARY) $(LDLIBS)
	$(CC) $(LDFLAGS) -o $@ $^

testminixml:	$(TESTMINIXMLOBJS)

testminiwget:	$(TESTMINIWGETOBJS)

minixmlvalid:	minixml.o minixmlvalid.o

testupnpreplyparse:	$(TESTUPNPREPLYPARSE)

testigddescparse:	$(TESTIGDDESCPARSE)

miniupnpcstrings.h:	miniupnpcstrings.h.in updateminiupnpcstrings.sh
	$(SH) updateminiupnpcstrings.sh

jar:	$(SHAREDLIBRARY) 
	$(JAVA) -jar $(JNAERATOR) -library miniupnpc miniupnpc.h declspec.h upnpcommands.h upnpreplyparse.h igd_desc_parse.h miniwget.h upnperrors.h $(SHAREDLIBRARY) -package fr.free.miniupnp -o . -jar java/miniupnpc_$(OS).jar -v

# DO NOT DELETE THIS LINE -- make depend depends on it.

igd_desc_parse.o: igd_desc_parse.h
miniupnpc.o: miniupnpc.h declspec.h igd_desc_parse.h minissdpc.h miniwget.h
miniupnpc.o: minisoap.h minixml.h upnpcommands.h upnpreplyparse.h
miniupnpc.o: connecthostport.h
minixml.o: minixml.h
minisoap.o: minisoap.h miniupnpcstrings.h
miniwget.o: miniupnpc.h declspec.h igd_desc_parse.h miniupnpcstrings.h
miniwget.o: miniwget.h connecthostport.h
upnpc.o: miniwget.h declspec.h miniupnpc.h igd_desc_parse.h upnpcommands.h
upnpc.o: upnpreplyparse.h upnperrors.h
upnpcommands.o: upnpcommands.h upnpreplyparse.h declspec.h miniupnpc.h
upnpcommands.o: igd_desc_parse.h
upnpreplyparse.o: upnpreplyparse.h minixml.h
testminixml.o: minixml.h igd_desc_parse.h
minixmlvalid.o: minixml.h
testupnpreplyparse.o: upnpreplyparse.h
minissdpc.o: minissdpc.h miniupnpc.h declspec.h igd_desc_parse.h codelength.h
upnperrors.o: upnperrors.h declspec.h upnpcommands.h upnpreplyparse.h
testigddescparse.o: igd_desc_parse.h minixml.h miniupnpc.h declspec.h
testminiwget.o: miniwget.h declspec.h
connecthostport.o: connecthostport.h

## miniupnpc 1.6

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

project (miniupnpc C)
set (MINIUPNPC_VERSION 1.5)
set (MINIUPNPC_API_VERSION 8)

if (NOT CMAKE_BUILD_TYPE)
  if (WIN32)
    set (DEFAULT_BUILD_TYPE MinSizeRel)
  else (WIN32)
    set (DEFAULT_BUILD_TYPE RelWithDebInfo)
  endif(WIN32)
    set (CMAKE_BUILD_TYPE ${DEFAULT_BUILD_TYPE} CACHE STRING
        "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
endif()

option (UPNPC_BUILD_STATIC "Build static library" TRUE)
option (UPNPC_BUILD_SHARED "Build shared library" TRUE)
if (NOT WIN32)
  option (UPNPC_BUILD_TESTS "Build test executables" TRUE)
endif (NOT WIN32)
option (NO_GETADDRINFO "Define NO_GETADDRINFO" FALSE)

mark_as_advanced (NO_GETADDRINFO)

if (NO_GETADDRINFO)
  add_definitions (-DNO_GETADDRINFO)
endif (NO_GETADDRINFO)

if (NOT WIN32)
  add_definitions (-DMINIUPNPC_SET_SOCKET_TIMEOUT)
else (NOT WIN32)
  add_definitions (-D_WIN32_WINNT=0x0501) # XP or higher for getnameinfo and friends
endif (NOT WIN32)

if (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
  add_definitions (-DMACOSX -D_DARWIN_C_SOURCE)
endif ()

# Set compiler specific build flags
if (CMAKE_COMPILER_IS_GNUC)
  # Set our own default flags at first run.
  if (NOT CONFIGURED)

    if (NOT CMAKE_SYSTEM_NAME STREQUAL "AmigaOS")
      set (_PIC -fPIC)
    endif (CMAKE_SYSTEM_NAME STREQUAL "AmigaOS")

    set (CMAKE_C_FLAGS "${_PIC} -Wall $ENV{CFLAGS}" # CMAKE_C_FLAGS gets appended to the other C flags
        CACHE STRING "Flags used by the C compiler during normal builds." FORCE)
    set (CMAKE_C_FLAGS_DEBUG "-g -DDDEBUG"
        CACHE STRING "Flags used by the C compiler during debug builds." FORCE)
    set (CMAKE_C_FLAGS_RELEASE "-O2 -DNDEBUG"
        CACHE STRING "Flags used by the C compiler during release builds." FORCE)
    set (CMAKE_C_FLAGS_RELWITHDEBINFO "-O2 -g -DNDEBUG"
        CACHE STRING "Flags used by the C compiler during release builds." FORCE)
    set (CMAKE_C_FLAGS_MINSIZEREL "-Os -DNDEBUG"
        CACHE STRING "Flags used by the C compiler during release builds." FORCE)

  endif (NOT CONFIGURED)
endif ()

configure_file (${CMAKE_SOURCE_DIR}/miniupnpcstrings.h.cmake ${CMAKE_BINARY_DIR}/miniupnpcstrings.h)
include_directories (${CMAKE_BINARY_DIR})

set (MINIUPNPC_SOURCES
  igd_desc_parse.c
  miniupnpc.c
  minixml.c
  minisoap.c
  miniwget.c
  upnpc.c
  upnpcommands.c
  upnpreplyparse.c
  upnperrors.c
  connecthostport.c
  portlistingparse.c
)

if (NOT WIN32 AND NOT CMAKE_SYSTEM_NAME STREQUAL "AmigaOS")
  set (MINIUPNPC_SOURCES ${MINIUPNPC_SOURCES} minissdpc.c)
endif (NOT WIN32 AND NOT CMAKE_SYSTEM_NAME STREQUAL "AmigaOS")

if (WIN32)
  set_source_files_properties (${MINIUPNPC_SOURCES} PROPERTIES
                                                    COMPILE_DEFINITIONS STATICLIB
                                                    COMPILE_DEFINITIONS MINIUPNP_EXPORTS
  )
endif (WIN32)

if (WIN32)
  find_library (WINSOCK2_LIBRARY NAMES ws2_32 WS2_32 Ws2_32)
  find_library (IPHLPAPI_LIBRARY NAMES iphlpapi)
  set (LDLIBS ${WINSOCK2_LIBRARY} ${IPHLPAPI_LIBRARY} ${LDLIBS})
#elseif (CMAKE_SYSTEM_NAME STREQUAL "Solaris")
#  find_library (SOCKET_LIBRARY NAMES socket)
#  find_library (NSL_LIBRARY NAMES nsl)
#  find_library (RESOLV_LIBRARY NAMES resolv)
#  set (LDLIBS ${SOCKET_LIBRARY} ${NSL_LIBRARY} ${RESOLV_LIBRARY} ${LDLIBS})
endif (WIN32)

if (NOT UPNPC_BUILD_STATIC AND NOT UPNPC_BUILD_SHARED)
    message (FATAL "Both shared and static libraries are disabled!")
endif (NOT UPNPC_BUILD_STATIC AND NOT UPNPC_BUILD_SHARED)

if (UPNPC_BUILD_STATIC)
  add_library (upnpc-static STATIC ${MINIUPNPC_SOURCES})
  set_target_properties (upnpc-static PROPERTIES OUTPUT_NAME "miniupnpc")
  target_link_libraries (upnpc-static ${LDLIBS})
  set (UPNPC_INSTALL_TARGETS ${UPNPC_INSTALL_TARGETS} upnpc-static)
  set (UPNPC_LIBRARY_TARGET upnpc-static)
endif (UPNPC_BUILD_STATIC)

if (UPNPC_BUILD_SHARED)
  add_library (upnpc-shared SHARED ${MINIUPNPC_SOURCES})
  set_target_properties (upnpc-shared PROPERTIES OUTPUT_NAME "miniupnpc")
  set_target_properties (upnpc-shared PROPERTIES VERSION ${MINIUPNPC_VERSION})
  set_target_properties (upnpc-shared PROPERTIES SOVERSION ${MINIUPNPC_API_VERSION})
  target_link_libraries (upnpc-shared ${LDLIBS})
  set (UPNPC_INSTALL_TARGETS ${UPNPC_INSTALL_TARGETS} upnpc-shared)
  set (UPNPC_LIBRARY_TARGET upnpc-shared)
endif (UPNPC_BUILD_SHARED)

if (UPNPC_BUILD_TESTS)
  add_executable (testminixml testminixml.c minixml.c igd_desc_parse.c)
  target_link_libraries (testminixml ${LDLIBS})

  add_executable (minixmlvalid minixmlvalid.c minixml.c)
  target_link_libraries (minixmlvalid ${LDLIBS})

  add_executable (testupnpreplyparse testupnpreplyparse.c
                                     minixml.c upnpreplyparse.c)
  target_link_libraries (testupnpreplyparse ${LDLIBS})

  add_executable (testigddescparse testigddescparse.c
                                   igd_desc_parse.c minixml.c miniupnpc.c miniwget.c minissdpc.c
                                   upnpcommands.c upnpreplyparse.c minisoap.c connecthostport.c
                                   portlistingparse.c
  )
  target_link_libraries (testigddescparse ${LDLIBS})

  add_executable (testminiwget testminiwget.c
                               miniwget.c miniupnpc.c minisoap.c upnpcommands.c minissdpc.c
                               upnpreplyparse.c minixml.c igd_desc_parse.c connecthostport.c
                               portlistingparse.c
  )
  target_link_libraries (testminiwget ${LDLIBS})

# set (UPNPC_INSTALL_TARGETS ${UPNPC_INSTALL_TARGETS} testminixml minixmlvalid testupnpreplyparse testigddescparse testminiwget)
endif (UPNPC_BUILD_TESTS)


install (TARGETS ${UPNPC_INSTALL_TARGETS}
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib${LIB_SUFFIX}
  ARCHIVE DESTINATION lib${LIB_SUFFIX}
)
install (FILES
	miniupnpc.h
  miniwget.h
  upnpcommands.h
  igd_desc_parse.h
  upnpreplyparse.h
  upnperrors.h
  declspec.h
  DESTINATION include/miniupnpc
)

set (CONFIGURED YES CACHE INTERNAL "")

# vim: ts=2:sw=2

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
-# $Id: Makefile,v 1.68 2010/12/21 16:13:14 nanard Exp $
+# $Id: Makefile,v 1.81 2011/06/21 15:24:14 nanard Exp $
 # MiniUPnP Project
 # http://miniupnp.free.fr/
-# (c) 2005-2010 Thomas Bernard
+# (c) 2005-2011 Thomas Bernard
 # to install use :
 # $ PREFIX=/tmp/dummylocation make install
 # or
@@ -12,7 +12,7 @@
 CC ?= gcc
 #AR = gar
 #CFLAGS = -O -Wall -g -DDEBUG
-CFLAGS ?= -O -Wall -DNDEBUG -DMINIUPNPC_SET_SOCKET_TIMEOUT
+CFLAGS ?= -O -Wall -DNDEBUG -DMINIUPNPC_SET_SOCKET_TIMEOUT -Wstrict-prototypes
 # -DNO_GETADDRINFO
 INSTALL = install
 SH = /bin/sh
@@ -23,17 +23,17 @@
 #LDLIBS=-lsocket -lnsl -lresolv
 
 # APIVERSION is used to build SONAME
-APIVERSION = 5
+APIVERSION = 8
 
 SRCS = igd_desc_parse.c miniupnpc.c minixml.c minisoap.c miniwget.c \
        upnpc.c upnpcommands.c upnpreplyparse.c testminixml.c \
 	   minixmlvalid.c testupnpreplyparse.c minissdpc.c \
 	   upnperrors.c testigddescparse.c testminiwget.c \
-       connecthostport.c
+       connecthostport.c portlistringparse.c receivedata.c
 
 LIBOBJS = miniwget.o minixml.o igd_desc_parse.o minisoap.o \
           miniupnpc.o upnpreplyparse.o upnpcommands.o upnperrors.o \
-          connecthostport.o
+          connecthostport.o portlistingparse.o receivedata.o
 
 ifneq ($(OS), AmigaOS)
 CFLAGS := -fPIC $(CFLAGS)
@@ -44,7 +44,10 @@
 
 # HEADERS to install
 HEADERS = miniupnpc.h miniwget.h upnpcommands.h igd_desc_parse.h \
-          upnpreplyparse.h upnperrors.h declspec.h
+          upnpreplyparse.h upnperrors.h miniupnpctypes.h \
+          portlistingparse.h \
+          declspec.h
+
 # library names
 LIBRARY = libminiupnpc.a
 ifeq ($(OS), Darwin)
@@ -62,15 +65,14 @@
 
 TESTMINIXMLOBJS = minixml.o igd_desc_parse.o testminixml.o
 
-TESTMINIWGETOBJS = miniwget.o testminiwget.o miniupnpc.o minisoap.o \
-                   upnpcommands.o upnpreplyparse.o minixml.o \
-                   igd_desc_parse.o connecthostport.o
+TESTMINIWGETOBJS = miniwget.o testminiwget.o connecthostport.o receivedata.o
 
 TESTUPNPREPLYPARSE = testupnpreplyparse.o minixml.o upnpreplyparse.o
 
 TESTIGDDESCPARSE = testigddescparse.o igd_desc_parse.o minixml.o \
                    miniupnpc.o miniwget.o upnpcommands.o upnpreplyparse.o \
-                   minisoap.o connecthostport.o
+                   minisoap.o connecthostport.o receivedata.o \
+                   portlistingparse.o
 
 ifneq ($(OS), AmigaOS)
 EXECUTABLES := $(EXECUTABLES) upnpc-shared
@@ -90,12 +92,13 @@
 endif
 
 
-.PHONY:	install clean depend all check everything installpythonmodule \
-	validateminixml
+.PHONY:	install clean depend all check everything \
+	installpythonmodule
+#	validateminixml validateminiwget
 
 all:	$(LIBRARY) $(EXECUTABLES)
 
-check:	validateminixml
+check:	validateminixml validateminiwget
 
 everything:	all $(EXECUTABLES_ADDTESTS)
 
@@ -109,6 +112,11 @@
 validateminixml:	minixmlvalid
 	@echo "minixml validation test"
 	./minixmlvalid
+	touch $@
+
+validateminiwget:	testminiwget minihttptestserver testminiwget.sh
+	@echo "miniwget validation test"
+	./testminiwget.sh
 	touch $@
 
 clean:
@@ -175,26 +183,32 @@
 jar:	$(SHAREDLIBRARY) 
 	$(JAVA) -jar $(JNAERATOR) -library miniupnpc miniupnpc.h declspec.h upnpcommands.h upnpreplyparse.h igd_desc_parse.h miniwget.h upnperrors.h $(SHAREDLIBRARY) -package fr.free.miniupnp -o . -jar java/miniupnpc_$(OS).jar -v
 
+minihttptestserver:	minihttptestserver.o
+
 # DO NOT DELETE THIS LINE -- make depend depends on it.
 
 igd_desc_parse.o: igd_desc_parse.h
 miniupnpc.o: miniupnpc.h declspec.h igd_desc_parse.h minissdpc.h miniwget.h
 miniupnpc.o: minisoap.h minixml.h upnpcommands.h upnpreplyparse.h
-miniupnpc.o: connecthostport.h
+miniupnpc.o: portlistingparse.h miniupnpctypes.h connecthostport.h
+miniupnpc.o: receivedata.h
 minixml.o: minixml.h
 minisoap.o: minisoap.h miniupnpcstrings.h
-miniwget.o: miniupnpc.h declspec.h igd_desc_parse.h miniupnpcstrings.h
-miniwget.o: miniwget.h connecthostport.h
+miniwget.o: miniupnpcstrings.h miniwget.h declspec.h connecthostport.h
+miniwget.o: receivedata.h
 upnpc.o: miniwget.h declspec.h miniupnpc.h igd_desc_parse.h upnpcommands.h
-upnpc.o: upnpreplyparse.h upnperrors.h
-upnpcommands.o: upnpcommands.h upnpreplyparse.h declspec.h miniupnpc.h
-upnpcommands.o: igd_desc_parse.h
+upnpc.o: upnpreplyparse.h portlistingparse.h miniupnpctypes.h upnperrors.h
+upnpcommands.o: upnpcommands.h upnpreplyparse.h portlistingparse.h declspec.h
+upnpcommands.o: miniupnpctypes.h miniupnpc.h igd_desc_parse.h
 upnpreplyparse.o: upnpreplyparse.h minixml.h
 testminixml.o: minixml.h igd_desc_parse.h
 minixmlvalid.o: minixml.h
 testupnpreplyparse.o: upnpreplyparse.h
 minissdpc.o: minissdpc.h miniupnpc.h declspec.h igd_desc_parse.h codelength.h
 upnperrors.o: upnperrors.h declspec.h upnpcommands.h upnpreplyparse.h
+upnperrors.o: portlistingparse.h miniupnpctypes.h miniupnpc.h
+upnperrors.o: igd_desc_parse.h
 testigddescparse.o: igd_desc_parse.h minixml.h miniupnpc.h declspec.h
 testminiwget.o: miniwget.h declspec.h
 connecthostport.o: connecthostport.h
+receivedata.o: receivedata.h

=== debian/changelog ===
miniupnpc (1.6-4ubuntu1) utopic; urgency=medium

  * Resynchronise with Debian.  Remaining changes:
    - Suggest minissdpd rather than recommending it, as it's in universe.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 05 Jun 2014 10:23:58 +0100

miniupnpc (1.6-4) unstable; urgency=high

  * Fixed potential buffer overrun in miniwget.c (Closes: #748913).

 -- Thomas Goirand <zigo@debian.org>  Wed, 28 May 2014 06:07:40 +0000

miniupnpc (1.6-3ubuntu2) quantal; urgency=low

  * Rebuild for new armel compiler default of ARMv5t.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 05 Oct 2012 13:56:24 +0100

miniupnpc (1.6-3ubuntu1) precise; urgency=low

  * Resynchronized on Debian using their git version, remaining difference:
  * control: suggests minissdpd rather than recommends, it's in universe

 -- Sebastien Bacher <seb128@ubuntu.com>  Tue, 06 Dec 2011 15:39:46 +0100

miniupnpc (1.6-3) unstable; urgency=low

  [Laurent Bigonville <bigon@debian.org>]
  * debian/libminiupnpc8.symbols: Add symbols file (Closes: #635531)
  * Drop debian/libminiupnpc8.shlibs, let dh_makeshlibs generate it.
  * debian/rules:
    - Call dh_makeshlibs with "-V -- -c4" parameters
    - Call dh_fixperms during build (Closes: #650202)

  [Thomas Goirand]
  * Uploading to unstable.
  * Added a new debian/gbp.conf.
  * Switching to source format 3.0 (quilt)
  * Build python bindings (python-miniupnpc), thanks to Adam Cécile
    <gandalf@le-vert.net> for his contribution (Closes: #660938).
  * Added multiarch support.
  * Uploading to unstable.
  * Fixes FTBFS on hurd, thanks to Svante Signell <svante.signell@gmail.com>
    (Closes: #718519).
  * VCS URLs are now canonical.
  * Standards-Version is now 3.9.4.

 -- Thomas Goirand <zigo@debian.org>  Thu, 23 Feb 2012 13:18:36 +0800

miniupnpc (1.6-2) experimental; urgency=low

  * Moved libminiupnpc.a in the -dev package as it should.
  * Added Replaces: libminiupnpc5, libminiupnpc8 (<= 1.6-1) because of above.

 -- Thomas Goirand <zigo@debian.org>  Fri, 11 Nov 2011 16:48:35 +0800

miniupnpc (1.6-1) experimental; urgency=low

  [Thomas Goirand <zigo@debian.org>]
  * New upstream version (Closes: #647679).
  * Rewrapped debian/copyrigh.
  * Uploading to experimental since there's an soname transition.
  [Leo 'costela' Antunes <costela@debian.org>]
  * Fixes watch file.
  * Update soname and binary lib package name.
  * Adds debian/rules build-arch and build-indep targets.
  * remove unneeded libminiupnpc.substvars.
  * policy bump to 3.9.2 (no changes).
  * fix debian/copyright syntax (empty lines).

 -- Thomas Goirand <zigo@debian.org>  Fri, 11 Nov 2011 16:21:41 +0800

miniupnpc (1.5-3) unstable; urgency=low

  * debian/copyright is now in correct DEP5 format.

 -- Thomas Goirand <zigo@debian.org>  Thu, 04 Aug 2011 18:52:03 +0800

miniupnpc (1.5-2) unstable; urgency=low

  * libminiupnpc-dev now depends on libminiupnpc5 (Closes: #617774).

 -- Thomas Goirand <zigo@debian.org>  Fri, 11 Mar 2011 18:59:58 +0800

miniupnpc (1.5-1) unstable; urgency=low

  * New upstream version.
  * Moving from experimental to unstable (Closes: #616632).

 -- Thomas Goirand <zigo@debian.org>  Thu, 10 Mar 2011 00:22:40 +0800

miniupnpc (1.4.20101221-1) experimental; urgency=low

  * Initial release. (Closes: #444392)

 -- Thomas Goirand <zigo@debian.org>  Wed, 29 Dec 2010 16:49:20 +0800

=== debian/control ===
Source: miniupnpc
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Thomas Goirand <zigo@debian.org>
Build-Depends: debhelper (>= 9), python-all-dev (>= 2.6.6-3~)
Standards-Version: 3.9.4
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/zigo/miniupnpc.git
Vcs-Git: http://anonscm.debian.org/git/users/zigo/miniupnpc.git
Homepage: http://miniupnp.free.fr/

Package: miniupnpc
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: foreign
Suggests: minissdpd
Description: UPnP IGD client lightweight library client
 The UPnP protocol is supported by most home adsl/cable routers and Microsoft
 Windows 2K/XP. The aim of the MiniUPnP project is to bring a free software
 solution to support the "Internet Gateway Device" part of the protocol. The
 MediaServer/MediaRenderer UPnP protocol is also becoming very popular.
 .
 Miniupnpc aims at the simplest library possible, with the smallest footprint
 and no dependencies to other libraries such as XML parsers or HTTP
 implementations. All the code is pure ANSI C. Compiled on a x86 PC, the
 miniupnp client library have less than 15KB code size. For instance, the upnpc
 sample program is around 20KB. The miniupnp daemon is much smaller than any
 other IGD daemon and is ideal for using on low memory device for this reason.
 .
 This package is an example client for the library.

Package: libminiupnpc8
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Suggests: minissdpd
Description: UPnP IGD client lightweight library
 The UPnP protocol is supported by most home adsl/cable routers and Microsoft
 Windows 2K/XP. The aim of the MiniUPnP project is to bring a free software
 solution to support the "Internet Gateway Device" part of the protocol. The
 MediaServer/MediaRenderer UPnP protocol is also becoming very popular.
 .
 Miniupnpc aims at the simplest library possible, with the smallest footprint
 and no dependencies to other libraries such as XML parsers or HTTP
 implementations. All the code is pure ANSI C. Compiled on a x86 PC, the
 miniupnp client library have less than 15KB code size. For instance, the upnpc
 sample program is around 20KB. The miniupnp daemon is much smaller than any
 other IGD daemon and is ideal for using on low memory device for this reason.
 .
 This package contains the shared library.

Package: libminiupnpc-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, ${shlibs:Depends}, libminiupnpc8 (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Suggests: minissdpd
Replaces: libminiupnpc5, libminiupnpc8 (<= 1.6-1)
Description: UPnP IGD client lightweight library development files
 The UPnP protocol is supported by most home adsl/cable routers and Microsoft
 Windows 2K/XP. The aim of the MiniUPnP project is to bring a free software
 solution to support the "Internet Gateway Device" part of the protocol. The
 MediaServer/MediaRenderer UPnP protocol is also becoming very popular.
 .
 Miniupnpc aims at the simplest library possible, with the smallest footprint
 and no dependencies to other libraries such as XML parsers or HTTP
 implementations. All the code is pure ANSI C. Compiled on a x86 PC, the
 miniupnp client library have less than 15KB code size. For instance, the upnpc
 sample program is around 20KB. The miniupnp daemon is much smaller than any
 other IGD daemon and is ideal for using on low memory device for this reason.
 .
 This package contains development files needed to build using libminiupnpc

Package: python-miniupnpc
Architecture: any
Section: python
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}
Description: UPnP IGD client lightweight library Python bindings
 The UPnP protocol is supported by most home adsl/cable routers and Microsoft
 Windows 2K/XP. The aim of the MiniUPnP project is to bring a free software
 solution to support the "Internet Gateway Device" part of the protocol. The
 MediaServer/MediaRenderer UPnP protocol is also becoming very popular.
 .
 Miniupnpc aims at the simplest library possible, with the smallest footprint
 and no dependencies to other libraries such as XML parsers or HTTP
 implementations. All the code is pure ANSI C. Compiled on a x86 PC, the
 miniupnp client library have less than 15KB code size. For instance, the upnpc
 sample program is around 20KB. The miniupnp daemon is much smaller than any
 other IGD daemon and is ideal for using on low memory device for this reason.
 .
 This package contains the Python bindings.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Python helper
-include /usr/share/python/python.mk

# All available python versions (python-support)
PYVERS  := $(shell pyversions -rv)

# CFLAGS
CFLAGS = -Wall -g
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

build: build-all $(PYVERS:%=build-python%)

build: build-all-stamp
build-all: build-all-stamp
build-all-stamp:
	dh_testdir
	$(MAKE)
	touch $@

$(PYVERS:%=build-python%): build-all-stamp $(PYVERS:%=build-python%-stamp)
build-python%-stamp:
	CFLAGS="$(CFLAGS)" python$* setup.py build
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp portlistingparse.o build-python*-stamp

	$(MAKE) clean
	dh_clean

install: build install-prereq install-all $(PYVERS:%=install-python%)

install-prereq:
	dh_testdir
	dh_testroot
	dh_prep

install-all: install-all-stamp
install-all-stamp: install-prereq
	$(MAKE) install PREFIX=$(CURDIR)/debian/miniupnpc INSTALLDIRLIB=$(CURDIR)/debian/miniupnpc/usr/lib/$(DEB_HOST_MULTIARCH)
	# Move the library in its corresponding separate package folder.
	mkdir -p $(CURDIR)/debian/libminiupnpc8/usr
	mv $(CURDIR)/debian/miniupnpc/usr/lib $(CURDIR)/debian/libminiupnpc8/usr
	# Move the include files
	mkdir -p $(CURDIR)/debian/libminiupnpc-dev/usr/lib
	mv $(CURDIR)/debian/miniupnpc/usr/include $(CURDIR)/debian/libminiupnpc-dev/usr
	mkdir -p $(CURDIR)/debian/libminiupnpc-dev/usr/lib/$(DEB_HOST_MULTIARCH)
	mv $(CURDIR)/debian/libminiupnpc8/usr/lib/$(DEB_HOST_MULTIARCH)/libminiupnpc.so $(CURDIR)/debian/libminiupnpc-dev/usr/lib/$(DEB_HOST_MULTIARCH)
	mv $(CURDIR)/debian/libminiupnpc8/usr/lib/$(DEB_HOST_MULTIARCH)/libminiupnpc.a $(CURDIR)/debian/libminiupnpc-dev/usr/lib/$(DEB_HOST_MULTIARCH)

$(PYVERS:%=install-python%): $(PYVERS:%=install-python%-stamp)
install-python%-stamp: install-all-stamp
	python$* setup.py install --root=$(CURDIR)/debian/python-miniupnpc --no-compile $(py_setup_install_args)

binary-indep: build install

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs Changelog.txt
	dh_installdocs
	dh_installman
	dh_python2
	dh_strip
	dh_compress
	dh_fixperms
	dh_makeshlibs -V -- -c4
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure build-arch build-indep

## miniupnpc 1.9.20140610

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
 cmake_minimum_required (VERSION 2.6)
 
 project (miniupnpc C)
-set (MINIUPNPC_VERSION 1.5)
-set (MINIUPNPC_API_VERSION 8)
+set (MINIUPNPC_VERSION 1.9)
+set (MINIUPNPC_API_VERSION 10)
 
 if (NOT CMAKE_BUILD_TYPE)
   if (WIN32)
@@ -30,6 +30,7 @@
 
 if (NOT WIN32)
   add_definitions (-DMINIUPNPC_SET_SOCKET_TIMEOUT)
+  add_definitions (-D_BSD_SOURCE -D_POSIX_C_SOURCE=1)
 else (NOT WIN32)
   add_definitions (-D_WIN32_WINNT=0x0501) # XP or higher for getnameinfo and friends
 endif (NOT WIN32)
@@ -76,6 +77,7 @@
   upnperrors.c
   connecthostport.c
   portlistingparse.c
+  receivedata.c
 )
 
 if (NOT WIN32 AND NOT CMAKE_SYSTEM_NAME STREQUAL "AmigaOS")
@@ -84,7 +86,7 @@
 
 if (WIN32)
   set_source_files_properties (${MINIUPNPC_SOURCES} PROPERTIES
-                                                    COMPILE_DEFINITIONS STATICLIB
+                                                    COMPILE_DEFINITIONS MINIUPNP_STATICLIB
                                                     COMPILE_DEFINITIONS MINIUPNP_EXPORTS
   )
 endif (WIN32)
@@ -136,14 +138,14 @@
   add_executable (testigddescparse testigddescparse.c
                                    igd_desc_parse.c minixml.c miniupnpc.c miniwget.c minissdpc.c
                                    upnpcommands.c upnpreplyparse.c minisoap.c connecthostport.c
-                                   portlistingparse.c
+                                   portlistingparse.c receivedata.c
   )
   target_link_libraries (testigddescparse ${LDLIBS})
 
   add_executable (testminiwget testminiwget.c
                                miniwget.c miniupnpc.c minisoap.c upnpcommands.c minissdpc.c
                                upnpreplyparse.c minixml.c igd_desc_parse.c connecthostport.c
-                               portlistingparse.c
+                               portlistingparse.c receivedata.c
   )
   target_link_libraries (testminiwget ${LDLIBS})
 
@@ -163,6 +165,8 @@
   igd_desc_parse.h
   upnpreplyparse.h
   upnperrors.h
+  miniupnpctypes.h
+  portlistingparse.h
   declspec.h
   DESTINATION include/miniupnpc
 )

=== Makefile ===
--- 
+++ 
@@ -1,35 +1,67 @@
-# $Id: Makefile,v 1.81 2011/06/21 15:24:14 nanard Exp $
+# $Id: Makefile,v 1.108 2014/06/10 09:51:33 nanard Exp $
 # MiniUPnP Project
 # http://miniupnp.free.fr/
-# (c) 2005-2011 Thomas Bernard
+# http://miniupnp.tuxfamily.org/
+# https://github.com/miniupnp/miniupnp
+# (c) 2005-2014 Thomas Bernard
 # to install use :
-# $ PREFIX=/tmp/dummylocation make install
+# $ make DESTDIR=/tmp/dummylocation install
 # or
 # $ INSTALLPREFIX=/usr/local make install
-# or 
-# make install (will go to /usr/bin, /usr/lib, etc...)
+# or
+# $ make install (default INSTALLPREFIX is /usr)
 OS = $(shell uname -s)
+VERSION = $(shell cat VERSION)
+
+ifeq ($(OS), Darwin)
+JARSUFFIX=mac
+endif
+ifeq ($(OS), Linux)
+JARSUFFIX=linux
+endif
+ifneq (,$(findstring NT-5.1,$(OS)))
+JARSUFFIX=win32
+endif
+
+HAVE_IPV6 ?= yes
+export HAVE_IPV6
+
 CC ?= gcc
 #AR = gar
-#CFLAGS = -O -Wall -g -DDEBUG
-CFLAGS ?= -O -Wall -DNDEBUG -DMINIUPNPC_SET_SOCKET_TIMEOUT -Wstrict-prototypes
+#CFLAGS = -O -g -DDEBUG
+CFLAGS ?= -O
+CFLAGS += -Wall
+CFLAGS += -W -Wstrict-prototypes
+CFLAGS += -fno-common
+CFLAGS += -DMINIUPNPC_SET_SOCKET_TIMEOUT
+CFLAGS += -DMINIUPNPC_GET_SRC_ADDR
+CFLAGS += -D_BSD_SOURCE -D_POSIX_C_SOURCE=1
+CFLAGS += -ansi
 # -DNO_GETADDRINFO
 INSTALL = install
 SH = /bin/sh
 JAVA = java
 # see http://code.google.com/p/jnaerator/
-JNAERATOR = jnaerator-0.9.3.jar
-#following libs are needed on Solaris
-#LDLIBS=-lsocket -lnsl -lresolv
+#JNAERATOR = jnaerator-0.9.7.jar
+#JNAERATOR = jnaerator-0.9.8-shaded.jar
+#JNAERATORARGS = -library miniupnpc
+#JNAERATOR = jnaerator-0.10-shaded.jar
+JNAERATOR = jnaerator-0.11-shaded.jar
+JNAERATORARGS = -mode StandaloneJar -runtime JNAerator -library miniupnpc
+JNAERATORBASEURL = http://jnaerator.googlecode.com/files/
+
+ifeq (SunOS, $(OS))
+  LDFLAGS=-lsocket -lnsl -lresolv
+endif
 
 # APIVERSION is used to build SONAME
-APIVERSION = 8
+APIVERSION = 10
 
 SRCS = igd_desc_parse.c miniupnpc.c minixml.c minisoap.c miniwget.c \
        upnpc.c upnpcommands.c upnpreplyparse.c testminixml.c \
 	   minixmlvalid.c testupnpreplyparse.c minissdpc.c \
 	   upnperrors.c testigddescparse.c testminiwget.c \
-       connecthostport.c portlistringparse.c receivedata.c
+       connecthostport.c portlistingparse.c receivedata.c
 
 LIBOBJS = miniwget.o minixml.o igd_desc_parse.o minisoap.o \
           miniupnpc.o upnpreplyparse.o upnpcommands.o upnperrors.o \
@@ -54,9 +86,14 @@
   SHAREDLIBRARY = libminiupnpc.dylib
   SONAME = $(basename $(SHAREDLIBRARY)).$(APIVERSION).dylib
   CFLAGS := -DMACOSX -D_DARWIN_C_SOURCE $(CFLAGS)
-else 
+else
+ifeq ($(JARSUFFIX), win32)
+  SHAREDLIBRARY = miniupnpc.dll
+else
+  # Linux/BSD/etc.
   SHAREDLIBRARY = libminiupnpc.so
   SONAME = $(SHAREDLIBRARY).$(APIVERSION)
+endif
 endif
 
 EXECUTABLES = upnpc-static
@@ -80,11 +117,13 @@
 TESTIGDDESCPARSE := $(TESTIGDDESCPARSE) minissdpc.o
 endif
 
+LIBDIR ?= lib
 # install directories
 INSTALLPREFIX ?= $(PREFIX)/usr
 INSTALLDIRINC = $(INSTALLPREFIX)/include/miniupnpc
-INSTALLDIRLIB = $(INSTALLPREFIX)/lib
+INSTALLDIRLIB = $(INSTALLPREFIX)/$(LIBDIR)
 INSTALLDIRBIN = $(INSTALLPREFIX)/bin
+INSTALLDIRMAN = $(INSTALLPREFIX)/share/man
 
 FILESTOINSTALL = $(LIBRARY) $(EXECUTABLES)
 ifneq ($(OS), AmigaOS)
@@ -92,13 +131,15 @@
 endif
 
 
-.PHONY:	install clean depend all check everything \
-	installpythonmodule
+.PHONY:	install clean depend all check test everything \
+	installpythonmodule updateversion
 #	validateminixml validateminiwget
 
 all:	$(LIBRARY) $(EXECUTABLES)
 
-check:	validateminixml validateminiwget
+test:	check
+
+check:	validateminixml validateminiwget validateupnpreplyparse
 
 everything:	all $(EXECUTABLES_ADDTESTS)
 
@@ -108,6 +149,13 @@
 
 installpythonmodule:	pythonmodule
 	python setup.py install
+
+pythonmodule3:	$(LIBRARY) miniupnpcmodule.c setup.py
+	python3 setup.py build
+	touch $@
+
+installpythonmodule3:	pythonmodule3
+	python3 setup.py install
 
 validateminixml:	minixmlvalid
 	@echo "minixml validation test"
@@ -119,34 +167,58 @@
 	./testminiwget.sh
 	touch $@
 
+validateupnpreplyparse:	testupnpreplyparse testupnpreplyparse.sh
+	@echo "upnpreplyparse validation test"
+	./testupnpreplyparse.sh
+	touch $@
+
 clean:
 	$(RM) $(LIBRARY) $(SHAREDLIBRARY) $(EXECUTABLES) $(OBJS) miniupnpcstrings.h
+	$(RM) $(EXECUTABLES_ADDTESTS)
 	# clean python stuff
-	$(RM) pythonmodule validateminixml
+	$(RM) pythonmodule pythonmodule3
+	$(RM) validateminixml validateminiwget validateupnpreplyparse
 	$(RM) -r build/ dist/
 	#python setup.py clean
-
-install:	$(FILESTOINSTALL)
-	$(INSTALL) -d $(INSTALLDIRINC)
-	$(INSTALL) -m 644 $(HEADERS) $(INSTALLDIRINC)
-	$(INSTALL) -d $(INSTALLDIRLIB)
-	$(INSTALL) -m 644 $(LIBRARY) $(INSTALLDIRLIB)
-ifneq ($(OS), AmigaOS)
-	$(INSTALL) -m 644 $(SHAREDLIBRARY) $(INSTALLDIRLIB)/$(SONAME)
-	ln -fs $(SONAME) $(INSTALLDIRLIB)/$(SHAREDLIBRARY)
-endif
-	$(INSTALL) -d $(INSTALLDIRBIN)
+	# clean jnaerator stuff
+	$(RM) _jnaerator.* java/miniupnpc_$(OS).jar
+
+distclean: clean
+	$(RM) $(JNAERATOR) java/*.jar java/*.class out.errors.txt
+
+updateversion:	miniupnpc.h
+	cp miniupnpc.h miniupnpc.h.bak
+	sed 's/\(.*MINIUPNPC_API_VERSION\s\+\)[0-9]\+/\1$(APIVERSION)/' < miniupnpc.h.bak > miniupnpc.h
+
+install:	updateversion $(FILESTOINSTALL)
+	$(INSTALL) -d $(DESTDIR)$(INSTALLDIRINC)
+	$(INSTALL) -m 644 $(HEADERS) $(DESTDIR)$(INSTALLDIRINC)
+	$(INSTALL) -d $(DESTDIR)$(INSTALLDIRLIB)
+	$(INSTALL) -m 644 $(LIBRARY) $(DESTDIR)$(INSTALLDIRLIB)
+ifneq ($(OS), AmigaOS)
+	$(INSTALL) -m 644 $(SHAREDLIBRARY) $(DESTDIR)$(INSTALLDIRLIB)/$(SONAME)
+	ln -fs $(SONAME) $(DESTDIR)$(INSTALLDIRLIB)/$(SHAREDLIBRARY)
+endif
+	$(INSTALL) -d $(DESTDIR)$(INSTALLDIRBIN)
 ifeq ($(OS), AmigaOS)
-	$(INSTALL) -m 755 upnpc-static $(INSTALLDIRBIN)/upnpc
+	$(INSTALL) -m 755 upnpc-static $(DESTDIR)$(INSTALLDIRBIN)/upnpc
 else
-	$(INSTALL) -m 755 upnpc-shared $(INSTALLDIRBIN)/upnpc
-endif
-	$(INSTALL) -m 755 external-ip.sh $(INSTALLDIRBIN)/external-ip
+	$(INSTALL) -m 755 upnpc-shared $(DESTDIR)$(INSTALLDIRBIN)/upnpc
+endif
+	$(INSTALL) -m 755 external-ip.sh $(DESTDIR)$(INSTALLDIRBIN)/external-ip
+ifneq ($(OS), AmigaOS)
+	$(INSTALL) -d $(DESTDIR)$(INSTALLDIRMAN)/man3
+	$(INSTALL) man3/miniupnpc.3 $(DESTDIR)$(INSTALLDIRMAN)/man3/miniupnpc.3
+ifeq ($(OS), Linux)
+	gzip $(DESTDIR)$(INSTALLDIRMAN)/man3/miniupnpc.3
+endif
+endif
+
 
 cleaninstall:
-	$(RM) -r $(INSTALLDIRINC)
-	$(RM) $(INSTALLDIRLIB)/$(LIBRARY)
-	$(RM) $(INSTALLDIRLIB)/$(SHAREDLIBRARY)
+	$(RM) -r $(DESTDIR)$(INSTALLDIRINC)
+	$(RM) $(DESTDIR)$(INSTALLDIRLIB)/$(LIBRARY)
+	$(RM) $(DESTDIR)$(INSTALLDIRLIB)/$(SHAREDLIBRARY)
 
 depend:
 	makedepend -Y -- $(CFLAGS) -- $(SRCS) 2>/dev/null
@@ -156,15 +228,16 @@
 
 $(SHAREDLIBRARY):	$(LIBOBJS)
 ifeq ($(OS), Darwin)
-	$(CC) -dynamiclib $(LDFLAGS) -Wl,-install_name,$(SONAME) -o $@ $^ 
+#	$(CC) -dynamiclib $(LDFLAGS) -Wl,-install_name,$(SONAME) -o $@ $^
+	$(CC) -dynamiclib $(LDFLAGS) -Wl,-install_name,$(INSTALLDIRLIB)/$(SONAME) -o $@ $^
 else
 	$(CC) -shared $(LDFLAGS) -Wl,-soname,$(SONAME) -o $@ $^
 endif
 
-upnpc-static:	upnpc.o $(LIBRARY) $(LDLIBS)
+upnpc-static:	upnpc.o $(LIBRARY)
 	$(CC) $(LDFLAGS) -o $@ $^
 
-upnpc-shared:	upnpc.o $(SHAREDLIBRARY) $(LDLIBS)
+upnpc-shared:	upnpc.o $(SHAREDLIBRARY)
 	$(CC) $(LDFLAGS) -o $@ $^
 
 testminixml:	$(TESTMINIXMLOBJS)
@@ -177,11 +250,44 @@
 
 testigddescparse:	$(TESTIGDDESCPARSE)
 
-miniupnpcstrings.h:	miniupnpcstrings.h.in updateminiupnpcstrings.sh
+miniupnpcstrings.h:	miniupnpcstrings.h.in updateminiupnpcstrings.sh VERSION
 	$(SH) updateminiupnpcstrings.sh
 
-jar:	$(SHAREDLIBRARY) 
-	$(JAVA) -jar $(JNAERATOR) -library miniupnpc miniupnpc.h declspec.h upnpcommands.h upnpreplyparse.h igd_desc_parse.h miniwget.h upnperrors.h $(SHAREDLIBRARY) -package fr.free.miniupnp -o . -jar java/miniupnpc_$(OS).jar -v
+# ftp tool supplied with OpenBSD can download files from http.
+jnaerator-%.jar:
+	wget $(JNAERATORBASEURL)/$@ || \
+	curl -o $@ $(JNAERATORBASEURL)/$@ || \
+	ftp $(JNAERATORBASEURL)/$@
+
+jar: $(SHAREDLIBRARY)  $(JNAERATOR)
+	$(JAVA) -jar $(JNAERATOR) $(JNAERATORARGS) \
+	miniupnpc.h declspec.h upnpcommands.h upnpreplyparse.h \
+	igd_desc_parse.h miniwget.h upnperrors.h $(SHAREDLIBRARY) \
+	-package fr.free.miniupnp -o . -jar java/miniupnpc_$(JARSUFFIX).jar -v
+
+mvn_install:
+	mvn install:install-file -Dfile=java/miniupnpc_$(JARSUFFIX).jar \
+	 -DgroupId=com.github \
+	 -DartifactId=miniupnp \
+	 -Dversion=$(VERSION) \
+	 -Dpackaging=jar \
+	 -Dclassifier=$(JARSUFFIX) \
+	 -DgeneratePom=true \
+	 -DcreateChecksum=true
+
+# make .deb packages
+deb: /usr/share/pyshared/stdeb all
+	(python setup.py --command-packages=stdeb.command bdist_deb)
+
+# install .deb packages
+ideb:
+	(sudo dpkg -i deb_dist/*.deb)
+
+/usr/share/pyshared/stdeb: /usr/share/doc/python-all-dev
+	(sudo apt-get install python-stdeb)
+
+/usr/share/doc/python-all-dev:
+	(sudo apt-get install python-all-dev)
 
 minihttptestserver:	minihttptestserver.o

=== debian/changelog ===
miniupnpc (1.9.20140610-4ubuntu2) bionic; urgency=medium

  * SECURITY UPDATE: multiple overflows
    - debian/patches/CVE-2017-1000494-1.patch: properly initialize data
      structure for SOAP parsing in upnpreplyparse.c.
    - debian/patches/CVE-2017-1000494-2.patch: fix heap buffer overflow in
      minixml.c.
    - CVE-2017-1000494

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 07 Feb 2018 13:44:03 -0500

miniupnpc (1.9.20140610-4ubuntu1) artful; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Suggest minissdpd rather than recommending it, as it's in universe.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 15 Jun 2017 14:46:27 -0400

miniupnpc (1.9.20140610-4) unstable; urgency=high

  * Now uses a better patch from upstream for the buffer overflow issue.

 -- Thomas Goirand <zigo@debian.org>  Fri, 19 May 2017 17:46:54 +0200

miniupnpc (1.9.20140610-3ubuntu1) artful; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Suggest minissdpd rather than recommending it, as it's in universe.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 19 May 2017 11:15:14 -0400

miniupnpc (1.9.20140610-3) unstable; urgency=high

  * Add More_accurate_checking_while_writing_buffer_in_simpleUPnPcommand2.patch
    which fixes a buffer overflow.
  * CVE-2017-8798: integer signedness error. Applied upstream patch.
    (Closes: #862273).
  * Define define _DEFAULT_SOURCE do avoid FTBFS.

 -- Thomas Goirand <zigo@debian.org>  Thu, 18 May 2017 13:41:57 +0200

miniupnpc (1.9.20140610-2.1) unstable; urgency=high

  * Non-maintainer upload.
  * Add CVE-2015-6031.patch patch.
    CVE-2015-6031: Buffer overflow vulnerability in XML parser
    functionality. (Closes: #802650)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 25 Oct 2015 13:41:21 +0100

miniupnpc (1.9.20140610-2ubuntu2) wily; urgency=medium

  * SECURITY UPDATE: buffer overflow in XML parser (LP: #1506017)
    - debian/patches/CVE-2015-6031.patch: fix buffer overflow in
      igd_desc_parse.c
    - CVE-2015-6031

 -- Steve Beattie <sbeattie@ubuntu.com>  Thu, 15 Oct 2015 17:31:20 -0700

miniupnpc (1.9.20140610-2ubuntu1) vivid; urgency=low

  * Merge from Debian unstable (LP: #1387096).  Remaining changes:
    - Suggest minissdpd rather than recommending it, as it's in universe.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Thu, 30 Oct 2014 18:07:17 +0000

miniupnpc (1.9.20140610-2) unstable; urgency=medium

  * Uploading to unstable.

 -- Thomas Goirand <zigo@debian.org>  Sun, 13 Jul 2014 14:43:26 +0000

miniupnpc (1.9.20140610-1) experimental; urgency=medium

  * New upstream release. This fixes FTBFS in kFreeBSD.
  * Now switching to pristine tar Git packaging.
  * Adds correct-typo-in-manpage.patch.
  * Added a debian/libminiupnpc10.symbols file.

 -- Thomas Goirand <zigo@debian.org>  Wed, 11 Jun 2014 13:27:03 +0800

miniupnpc (1.9.20140401-1) experimental; urgency=medium

  * New upstream release (Closes: #748913, #698705)
  * Uploading to experimental because of the needed transition.
  * Enabled hardening build flags (Closes: #680214).
  * Removed 000-Setup.py_CFLAGS_override.patch now applied upstream.
  * Refreshed fix-ftbfs-on-hurd.patch.
  * Upstream bumped SONAME, so now packaging libminiupnpc10 instead of 8.
  * Switched to upstream branch tags git packaging. Note that upstream Git
    cannot be used directly, as it contains all projects of miniupnp in a
    single repository.
  * Removed patch applied upstream: debian/patches/fix-ftbfs-on-hurd.patch.
  * Bumped Standards-Version.

 -- Thomas Goirand <zigo@debian.org>  Wed, 28 May 2014 07:10:52 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Thomas Goirand <zigo@debian.org>
 Build-Depends: debhelper (>= 9), python-all-dev (>= 2.6.6-3~)
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/zigo/miniupnpc.git
 Vcs-Git: http://anonscm.debian.org/git/users/zigo/miniupnpc.git
 Homepage: http://miniupnp.free.fr/
@@ -29,7 +29,7 @@
  .
  This package is an example client for the library.
 
-Package: libminiupnpc8
+Package: libminiupnpc10
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
@@ -53,7 +53,7 @@
 Package: libminiupnpc-dev
 Architecture: any
 Section: libdevel
-Depends: ${misc:Depends}, ${shlibs:Depends}, libminiupnpc8 (= ${binary:Version})
+Depends: ${misc:Depends}, ${shlibs:Depends}, libminiupnpc10 (= ${binary:Version})
 Pre-Depends: ${misc:Pre-Depends}
 Suggests: minissdpd
 Replaces: libminiupnpc5, libminiupnpc8 (<= 1.6-1)
